Index: pycodebattler/trunk/pycodebattler/battle.py
===================================================================
--- pycodebattler/trunk/pycodebattler/battle.py	(revision 50)
+++ pycodebattler/trunk/pycodebattler/battle.py	(revision 71)
@@ -1,5 +1,16 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import os
Index: pycodebattler/trunk/pycodebattler/score.py
===================================================================
--- pycodebattler/trunk/pycodebattler/score.py	(revision 70)
+++ pycodebattler/trunk/pycodebattler/score.py	(revision 71)
@@ -1,4 +1,15 @@
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import os
Index: pycodebattler/trunk/pycodebattler/util.py
===================================================================
--- pycodebattler/trunk/pycodebattler/util.py	(revision 47)
+++ pycodebattler/trunk/pycodebattler/util.py	(revision 71)
@@ -1,4 +1,15 @@
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import os
Index: pycodebattler/trunk/pycodebattler/skill.py
===================================================================
--- pycodebattler/trunk/pycodebattler/skill.py	(revision 51)
+++ pycodebattler/trunk/pycodebattler/skill.py	(revision 71)
@@ -1,4 +1,15 @@
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import sys
Index: pycodebattler/trunk/pycodebattler/__init__.py
===================================================================
--- pycodebattler/trunk/pycodebattler/__init__.py	(revision 47)
+++ pycodebattler/trunk/pycodebattler/__init__.py	(revision 71)
@@ -1,4 +1,15 @@
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import pycodebattler.battle
Index: pycodebattler/trunk/pycodebattler/scouter.py
===================================================================
--- pycodebattler/trunk/pycodebattler/scouter.py	(revision 47)
+++ pycodebattler/trunk/pycodebattler/scouter.py	(revision 71)
@@ -1,5 +1,16 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 import sys
Index: pycodebattler/trunk/pycodebattler/warrior.py
===================================================================
--- pycodebattler/trunk/pycodebattler/warrior.py	(revision 52)
+++ pycodebattler/trunk/pycodebattler/warrior.py	(revision 71)
@@ -1,4 +1,15 @@
 # -*- coding: utf-8 -*-
+#
+#  Copyright (C) 2010 by Atzm WATANABE <atzm@atzm.org>
+#
+#  This program is free software; you can redistribute it and/or modify it
+#  under the terms of the GNU General Public License (version 2) as
+#  published by the Free Software Foundation.  It is distributed in the
+#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#  PURPOSE.  See the GNU General Public License for more details.
+#
 # $Id$
+#
 
 try: