Index: etherws/trunk/README.rst
===================================================================
--- etherws/trunk/README.rst	(revision 162)
+++ etherws/trunk/README.rst	(revision 170)
@@ -7,5 +7,5 @@
 ==========
 For example, if you want to make virtual ethernet link for *VM1* and *VM2*
-whose hypervisor's broadcast domains were split by router *R*::
+whose hypervisor's broadcast domains were isolated by router *R*::
 
   +------------------+            +------------------+
@@ -32,5 +32,5 @@
 on *Hypervisor1*::
 
-  # etherws server
+  # etherws --device ethws0 server
   # brctl addbr br0
   # brctl addif br0 vnet0
@@ -40,5 +40,5 @@
 on *Hypervisor2*::
 
-  # etherws client --uri ws://<Hypervisor1's IP address>/
+  # etherws --device ethws0 client --uri ws://<Hypervisor1's IP address>/
   # brctl addbr br0
   # brctl addif br0 vnet0
@@ -61,9 +61,9 @@
 =============
 etherws supports SSL/TLS connection.
-If you want to encrypt the tunnel, then you can use following options.
+If you want to encrypt tunnels, then you can use following options.
 
 on *Hypervisor1*::
 
-  # etherws server --keyfile ssl.key --certfile ssl.crt
+  # etherws --device ethws0 server --keyfile ssl.key --certfile ssl.crt
 
 *ssl.key* is a server private key, and *ssl.crt* is a server certificate.
@@ -75,5 +75,5 @@
 on *Hypervisor2*::
 
-  # etherws client --uri wss://<Hypervisor1's IP address>/ --cacerts ssl.crt
+  # etherws --device ethws0 client --uri wss://<Hypervisor1's IP address>/ --cacerts ssl.crt
 
 Here, URI scheme was just changed to *wss*, and CA certificate to verify
@@ -84,8 +84,8 @@
 self-signed certificate and client uses another CA certificate.
 
-If you want to just encrypt the tunnel and do not need to verify
+If you want to just encrypt tunnels and do not need to verify
 certificate, then you can use following option::
 
-  # etherws client --uri wss://<Hypervisor1's IP address>/ --insecure
+  # etherws --device ethws0 client --uri wss://<Hypervisor1's IP address>/ --insecure
 
 Note: see `<http://docs.python.org/library/ssl.html>`_
@@ -108,5 +108,5 @@
 To run server with this::
 
-  # etherws server --htpasswd filename
+  # etherws --device ethws0 server --htpasswd filename
 
 You also can test by following command::
@@ -120,6 +120,6 @@
 option or stdin::
 
-  # etherws client --uri ws://<address>/ --user username --passwd password
-  # etherws client --uri ws://<address>/ --user username
+  # etherws --device ethws0 client --uri ws://<address>/ --user username --passwd password
+  # etherws --device ethws0 client --uri ws://<address>/ --user username
   Password: 
 
@@ -129,6 +129,40 @@
 support, because it is insecure in itself.
 
+Complex Examples
+================
+etherws has simple virtual Ethernet switch in itself and it can handle multiple
+TAP interfaces or WebSocket connections as virtual switch port::
+
+  (A)# etherws --device ethws0 --device ethws1 --device ethws2 server
+  (B)# etherws --device ethws0 server
+  (C)# etherws --device ethws0 --device ethws1 client --uri ws://x.x.x.x/
+  (D)# etherws --device ethws0 client --uri ws://x.x.x.x/ --uri ws://y.y.y.y/
+
+This will create following network::
+
+       (ethws0)  (ethws1)  (ethws2)             (ethws0)
+           |        |         |                    |
+     +-----+--------+---------+-----+     +--------+--------+
+     |           server (A)         |     |   server (B)    |
+     |        (ws://x.x.x.x/)       |     | (ws://y.y.y.y/) |
+     +-----+------------------+-----+     +-----+-----------+
+           |                  |                 |
+           |    (WebSocket)   |    +------------+
+           |                  |    |
+   +-------+------+   +-------+----+--+
+   |  client (C)  |   |   client (D)  |
+   +--+--------+--+   +-------+-------+
+      |        |              |
+  (ethws0)  (ethws1)      (ethws0)
+
+Also you can use TAP interface which is created by etherws as 802.1Q VLAN
+interface using vconfig command and so on.
+
 History
 =======
+0.7 (2012-06-29 JST)
+  - switching support
+  - multiple ports support
+
 0.6 (2012-06-16 JST)
   - improve performance